<template>
  <div class="access-block"
       :class="styleBlock(this.accessLocal.access).class"
       :disabled="accessLocal.disabled"
       @click="showOption = !showOption"
       v-click-outside="closeOptions"
  >
    <div class="block-status">
      <i :class="'icon ' + styleBlock(this.accessLocal.access).iconName"></i>
    </div>
    <div class="block-status lock" v-if="accessLocal.disabled">
      <i class="icon lock -gray-slate"></i>
    </div>
    <div class="block-status moderator" v-if="accessLocal.moderator">
      <i class="icon role-system-moderator -gray-slate"></i>
    </div>
    <div class="block-text">
        {{access.type}}
    </div>
    <div class="status-changed" v-if="accessLocal.access !== access.access"></div>
      <transition name="fade">
          <div class="access-popover" v-if="showOption">
              <div
                      v-for="(item, index) in accessLocal.availableAccessList"
                      :key="index"
                      class="access-popover-option"
                      @click="changeSetting(item)"
              >
                  <div class="access-popover-option-icon">
                      <i :class="'icon ' + styleBlock(item.access).iconName"></i>
                  </div>
                  <div class="access-popover-option-txt">
                      <div class="title"> {{ item.name }} </div>
                      <div class="description"> {{ item.description }} </div>
                  </div>
              </div>
          </div>
      </transition>
  </div>
</template>

<script>
  import { VISIBILITY_PERMISSION, LINK_PERMISSION } from '../../../resources/log_domains_const'
  import ClickOutside from 'vue-click-outside'
  import cloneDeep from 'clone-deep'

export default {
  name: 'AccessBlock',
  props: {
    access: {
      type: Object,
      required: true
    },
    changeCount: {
      type: Number,
      default: 0
    }
  },
  directives: {
      ClickOutside
  },
  data: function () {
    return {
      showOption: false,
      accessLocal: {},
      changed: false
    }
  },
  watch: {
    'access.access' () {
      this.setDefaultValue()
    },
    changeCount () {
      if (this.changeCount === 0) this.setDefaultValue()
    }
  },
  mounted () {
    this.setDefaultValue()
  },
  methods: {
      setDefaultValue () {
        this.accessLocal = cloneDeep(this.access)
      },
      styleBlock (access) {
          switch (access) {
              case VISIBILITY_PERMISSION.VISIBILITY:
                  return {
                      class: 'allow',
                      iconName: 'profile-eye -caribbean-green'
                  };
              case VISIBILITY_PERMISSION.NOT_VISIBILITY:
              case LINK_PERMISSION.DISALLOWED:
                  return {
                      class: 'forbid',
                      iconName: 'close -light-raspberry-red'
                  };
              case LINK_PERMISSION.BY_REQUEST:
                  return {
                      class: 'agreement-link',
                      iconName: 'link -diamond-orange-yellow'
                  };
              case LINK_PERMISSION.ALLOWED:
                  return {
                      class: 'create-link',
                      iconName: 'link -caribbean-green'
                  };
          }
          return {
              class: '',
              iconSrc: ''
          };
      },
      closeOptions () {
        this.showOption = false
      },
      changeSetting (value) {
          if (this.accessLocal.access !== value.access) {
              this.accessLocal.access = value.access;
              this.$emit('change-setting', this.accessLocal, this.accessLocal.access !== this.access.access);
          }
      }
  }

}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  .icon {
    font-size: 16px;
  }
  .access-block {
      width: 20%;
      padding: 16px 16px 16px 40px;
      position: relative;
      margin-right: 2px;
      cursor: pointer;
      &:last-of-type {
          margin-right: 0;
      }
      &.allow {
          background: linear-gradient(0deg, rgba( $caribbean-green, 0.15 ), rgba( $caribbean-green, 0.15 )), white;
      }
      &.forbid {
          background: linear-gradient(0deg, rgba( $light-raspberry-red, 0.15 ), rgba( $light-raspberry-red, 0.15 )), white;
      }
      &.agreement-link {
          background: linear-gradient(0deg, rgba($diamond-orange-yellow, 0.15), rgba($diamond-orange-yellow, 0.15)), white;
      }
      &.create-link {
          background: linear-gradient(0deg, rgba( $caribbean-green, 0.15 ), rgba( $caribbean-green, 0.15 )), white;
      }
      &[disabled=disabled] {
          pointer-events: none;
          background: $very-light-black;
          position: relative;
      }
      .block-status {
          position: absolute;
          top: 16px;
          left: 12px;
          &.lock {
              bottom: 10px;
              top: auto;
          }
          &.moderator {
              bottom: 10px;
              top: auto;
              right: 12px;
              left: auto;
          }
      }
      .status-changed {
        background: $cobalt;
        border-radius: 50%;
        width: 5px;
        height: 5px;
        position: absolute;
        top: 16px;
        right: 12px;
      }
      .access-popover {
          padding: 20px;
          background: white;
          width: 260px;
          height: auto;
          position: absolute;
          top: 100%;
          left: 50%;
          transform: translate(-50%, 0);
          box-shadow: 0 4px 16px rgba($color-text-base, 0.24), 0px -1px 6px rgba($color-text-base, 0.08);
          z-index: 100;
          margin-bottom: 40px;
          border-radius: 4px;
          &::after {
              content: '';
              position: absolute;
              margin: auto;
              top: -16px;
              left: 50%;
              transform: translate(-50%, 0);
              border: 9px solid transparent;
              border-bottom: 8px solid white;
          }
          .access-popover-option {
              display: flex;
              margin-bottom: 20px;
              &:last-of-type {
                  margin-bottom: 0;
              }
              &-icon {
                  margin-right: 8px;
              }
              &-txt {
                  .title {
                      @include font-mixin(16px, 20px, 400, $cobalt-black, 0.2px);
                      margin-top: 1px;
                      margin-bottom: 10px;
                  }
                  .description {
                      @include font-mixin(13px, 20px, 400, $gray-slate, 0.4px);
                  }
              }
          }
      }
  }
  .fade-enter-active, .fade-leave-active {
      transition: opacity .3s;
  }
  .fade-enter, .fade-leave-to {
      opacity: 0;
  }
</style>
